#include "rijndael.h"
#include "klee/klee.h"

#define KEY "supersecretsupersecretsupersecretsupersecret"
#define KEY_LEN 128
#define INPUT_LEN 32

#define CRASHOPCODE 0x41


int
main (int argc, char *argv[])
{
  int ret;
  rijndael_ctx ctx;
  char input[16];
  char encrypted[16];
  char decrypted[16];

  /* mark input as symbolic */
  klee_make_symbolic (input, 16, "input");

  /* encrypt the symbolic input with our supersecret key */
  rijndael_set_key (&ctx, KEY, KEY_LEN, 0);
  rijndael_encrypt (&ctx, input, encrypted);

  /* and decrypt it back to its original form */
  rijndael_decrypt (&ctx, encrypted, decrypted);

  /** now lets emulate some crashing condition over the original text 
   * if the first byte (the opcode) is "A" flag there is something wrong 
   */
  if (decrypted[0] == CRASHOPCODE)
    {
      *(int *) 10 = 0;
    }
  return 0;
}
